
/* Chrysalide - Outil d'analyse de fichiers binaires
 * content.h - prototypes pour l'intégration de données partagées
 *
 * Copyright (C) 2016 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_SHARING_CONTAINER_H
#define _ARCH_SHARING_CONTAINER_H


#include <stdbool.h>
#include <glib-object.h>


#include "instance.h"



#define G_TYPE_SHARE_CONTAINER               (g_share_container_get_type())
#define G_SHARE_CONTAINER(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), G_TYPE_SHARE_CONTAINER, GShareContainer))
#define G_SHARE_CONTAINER_CLASS(vtable)      (G_TYPE_CHECK_CLASS_CAST((vtable), G_TYPE_SHARE_CONTAINER, GShareContainerIface))
#define GTK_IS_SHARE_CONTAINER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), G_TYPE_SHARE_CONTAINER))
#define GTK_IS_SHARE_CONTAINER_CLASS(vtable) (G_TYPE_CHECK_CLASS_TYPE((vtable), G_TYPE_SHARE_CONTAINER))
#define G_SHARE_CONTAINER_GET_IFACE(inst)    (G_TYPE_INSTANCE_GET_INTERFACE((inst), G_TYPE_SHARE_CONTAINER, GShareContainerIface))


/* Intégrateur de contenu partagé (coquille vide) */
typedef struct _GShareContainer GShareContainer;

/* Intégrateur de contenu partagé (interface) */
typedef struct _GShareContainerIface GShareContainerIface;


/* Détermine le type d'une interface pour l'intégration de contenu partagé. */
GType g_share_container_get_type(void) G_GNUC_CONST;

/* Assure la mise à jour du contenu d'un intégrateur. */
void g_share_container_replace(GShareContainer *, GSharedInstance *, GSharedInstance *);



#endif  /* _ARCH_SHARING_CONTAINER_H */
