
%top {

#include "grammar.h"

}


%option noyywrap
%option nounput
%option noinput
%option yylineno
%option stack
%option noyy_top_state

%x raw_line


%%


[ \t\n]+                { }

[A-Za-z_][A-Za-z0-9_]*  { yylvalp->string = strdup(yytext); return NAME; }

"="                     { yy_push_state(raw_line); return EQ; }

<raw_line>[^\n]+        { yylvalp->cstring = yytext; return RAW_LINE; }
<raw_line>"\n"          { yy_pop_state(); }


%%
